;===============================================================================;
;      API-  
;: Bill Prisoner / TPOC 
;  : 6.10.2005
;===============================================================================;

;===============================================================================;
; startproc
;       
;: 
;:
;===============================================================================;
startproc macro
	push esi
	push edi
	push ebx
	push ebp
	pushfd
endm
;===============================================================================;

;===============================================================================;
; endproc
;    , ..    
;    startproc
;: 
;: 
;===============================================================================;
endproc macro
	popfd
	pop ebp
	pop ebx
	pop edi
	pop esi
endm
;===============================================================================;

;===============================================================================;
; GetDelta
; -
;: 
;:ebp - -
;===============================================================================;
GetDelta macro
call delta 
delta:
	pop ebp
	sub ebp,offset delta
endm
;===============================================================================;


;===============================================================================;
; api
;       , ..   
;      EBX
;: x -     
;:  
;===============================================================================;
apiproc macro x
	call [ebx+x]
endm
;===============================================================================;


;===============================================================================;
; api
;     
;: x -     
;:  
;===============================================================================;
api macro x
	call [ebp+x]
endm
;===============================================================================;

;===============================================================================;
; GetKernelSEH
;   kernel32.dll
;: 
;: eax -   kernel32.dll
;===============================================================================;
GetKernelSEH proc
	assume fs:flat;  .   assume fs:err
	mov eax,dword ptr fs:[0]; eax -    ERR
NextElem:
	cmp dword ptr [eax],-1; 
	je Yes
	mov eax,dword ptr [eax]
	jmp NextElem
Yes:;    
	mov eax,[eax+4]
	ret
GetKernelSEH endp
;===============================================================================;


;===============================================================================;
; GetGetProcAddress
;   kernel32.dll
;: 
;	KernelBase -  kernel32.dll
;	Delta - -
;:
;	 eax -   GetProcAddress
;===============================================================================;
GetGetProcAddress proc KernelBase:DWORD,Delta:DWORD
	startproc
	jmp GPA
GPAStr:
	db "GetProcAddressA"
GPA:	
	mov ecx,Delta	

	mov esi,KernelBase
	mov ebx,esi
	assume esi:ptr IMAGE_DOS_HEADER
	add esi,[esi].e_lfanew; esi -  PE

	assume esi:ptr IMAGE_NT_HEADERS
	lea esi,[esi].OptionalHeader; esi -   

	assume esi:ptr IMAGE_OPTIONAL_HEADER
	lea esi,[esi].DataDirectory; esi -  DataDirectory
	mov esi,dword ptr [esi]
	add esi,ebx; esi -  IMAGE_EXPORT_DIRECTORY
	push esi
	assume esi:ptr IMAGE_EXPORT_DIRECTORY
	mov esi,[esi].AddressOfNames
	add esi,ebx; esi -   
	xor edx,edx; edx -  

	mov eax,esi
	mov esi,dword ptr [esi]
NextName:;   
	add esi,ebx
	push ecx
	mov ecx,Delta
	lea edi,[ecx+GPAStr]
	pop ecx
	mov ecx,14;   "GetProcAddress"
	cld
	repe cmpsb
	.IF ecx==0; 
		jmp GetAddr
	.ENDIF
	inc edx
	add eax,4
	mov esi,dword ptr [eax]
	jmp NextName
GetAddr:;  "GetProcAddress"
	pop esi
	mov edi,esi
	mov esi,[esi].AddressOfNameOrdinals
	add esi,ebx; esi -    
	mov dx,word ptr [esi][edx*2]
	assume edi:ptr IMAGE_EXPORT_DIRECTORY
	sub edx,[edi].nBase;  
	inc edx;..     1
	mov esi,[edi].AddressOfFunctions
	add esi,ebx; esi -   
	mov eax,dword ptr [esi][edx*4]
	add eax,ebx; eax -   GetProcAddress
	ret
GetGetProcAddress endp	
;===============================================================================;


;===============================================================================;
; GetBase							
;:
;   ,    -  
;: Address     
;: eax -  PE-
;===============================================================================;
GetBase proc Address:DWORD
	startproc
	mov eax,FALSE
	mov esi,Address
	and esi,0FFFF0000H;  
	mov ecx,6; 
NextPage:;  
	push esi
	push esi
	call ValidPE
	pop esi
	.IF eax==1
		mov eax,esi
		endproc
		ret
	.ENDIF
	sub esi,10000H
	loop NextPage
	endproc
	ret
GetBase endp
;===============================================================================;


;===============================================================================;
; ValidPE
;:
;  PE-
;: Address -     
;:   ,  eax=1,  eax=0
;===============================================================================;
ValidPE proc Address:DWORD
	startproc
	mov eax,FALSE
	mov esi,Address
	.IF WORD ptr [esi]=="ZM"
		assume esi:ptr IMAGE_DOS_HEADER; ,   esi   IMAGE_DOS_HEADER
		add esi,[esi].e_lfanew;  PE 
		.IF WORD PTR [esi]=="EP"; ! ..      MZ,    e_lfanew    . ..  .  ,      ,          .
			mov eax,TRUE
		.ENDIF
	.ENDIF
	endproc
	ret
ValidPE endp
;===============================================================================;


;===============================================================================;
; GetKernelBase
;:
;  kernel32.dll
;: 
;: eax -  kernel32.dll
;===============================================================================;
GetKernelBase macro
	call GetKernelSEH
	push eax
	call GetBase
endm
;===============================================================================;


;===============================================================================;
; GetAPIs
;    API-
;: 
;	AddressNames -    ASCIIZ   
;	Addressess -       
;	Base -  DLL    
;	AddressGetProcAddress -   GetProcAddress
;	Number -  
;:  
;===============================================================================;
GetAPIs proc Number:DWORD,AddressNames:DWORD,Addressess:DWORD,Base:DWORD,Delta:DWORD
LOCAL AddressGetProcAddress:DWORD
	startproc
	mov ebx,Delta
	jmp GetAPIFunctionsStart
GetAPIFunctionsdata:
	db "GetProcAddress",0
GetAPIFunctionsStart:
	GetKernelBase
	push ebx
	push eax
	call GetGetProcAddress
	mov AddressGetProcAddress,eax

	mov ebx,Addressess
	mov esi,Base
	mov edi,AddressNames
	mov eax,AddressGetProcAddress
	mov ecx,Number
NextFunc:
	push eax
	push esi
	push edi
	push ebx
	push ecx

	push edi; 
	push esi; kernel32
	call eax; GetProcAddress
	
	pop ecx
	pop ebx
	pop edi
	pop esi

	mov dword ptr [ebx],eax;    
	pop eax
	add ebx,4; 
	push ecx; 
	mov ecx,30;  
	push eax
	mov al,0; 0
	repne scasb
	pop eax
	pop ecx
	loop NextFunc
	endproc
	ret
GetAPIs endp
;===============================================================================;