;===============================================================================;
;,      SEH  
;: Bill Prisoner / TPOC 
;  : 6.10.2005
;===============================================================================;

SEH struct
	PrevLink dd ?    ;   SEH-
	CurrentHandler dd ?    ;   
	SafeOffset dd ?    ;   
	PrevEsp dd ?      ;   esp
	PrevEbp dd ?     ;   ebp
SEH ends

;===============================================================================;
; SEHHandler
;        
;:  , ..      VDK
;:  , ..      VDK
;===============================================================================;
SEHHandler proc pExcept:DWORD, pFrame:DWORD, pContext:DWORD, pDispatch:DWORD
	mov edx,pFrame
	assume edx:ptr SEH
	mov eax,pContext
	assume eax:ptr CONTEXT
	push [edx].SafeOffset
	pop [eax].regEip
	push [edx].PrevEsp
	pop [eax].regEsp
	push [edx].PrevEbp
	pop [eax].regEbp
	mov eax,ExceptionContinueExecution
	ret
SEHHandler endp
;===============================================================================;


;===============================================================================;
; CreateSEHFrameEx
; SEH-.          .
;  ,        Goto.
;: 
;	Goto -  ,    
;	Delta - -
;	_EBP -   ebp      Goto
;	_ESP -   esp      Goto
;
;:	
;===============================================================================;
CreateSEHFrameEx macro Goto,Delta,_EBP,_ESP
	assume fs:nothing
	push _EBP
	push _ESP
	push Goto
	mov ebx,Delta
	lea eax,[ebx+SEHHandler]
	push eax
	push FS:[0]
	mov FS:[0],ESP
endm
;===============================================================================;


;===============================================================================;
; CreateSEHFrame
; SEH-.          .
;  ,        Goto.  
; CreateSEHFrame   EBP  ESP,   .  ,  
;    .
;: 
;	Goto -  ,    
;	Delta - -
;
;:	
;===============================================================================;
CreateSEHFrame macro Goto,Delta
	assume fs:nothing
	push ebp
	push esp
	push Goto
	mov ebx,Delta
	lea eax,[ebx+SEHHandler]
	push eax
	push FS:[0]
	mov FS:[0],ESP
endm
;===============================================================================;


;===============================================================================;
; DeleteSEHFrame
;    SEH-.   
; CreateSEHFrame  CreateSEHFrameEx.         
;  CreateSEHFrame.
;: 
;:	
;===============================================================================;
DeleteSEHFrame macro
	pop FS:[0];  FS:[0]    ERR
	add ESP,16;       
endm
;===============================================================================;